Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Time tracking Estimated time: 0.00 hour
Target version:

Resolution: Fixed Affected version: 5.1.0
Description

Time entry details fetch query load issue.

when, i remove where clause query gets executed quickly.(l know the where clause is important to validate the module is enabled for
the project).

In JOIN clauses, The query validates issue_tracking module is enabled or not.

again in WHERE Clause, The validation happens for time_tracking module.

In this case, when join exec happens 4496 columns filtered

when exec move to LEFT OUTER JOIN, issue_tracking module validation. 1181 rows get filtered.

Now in where clause another 1181 again.

(4496 * 1181 * 1181) now of rows examined in query is inceased.

SELECT
FROM

‘time_entries’

*id' AS t0_roO,
‘project_id® AS tO_rl,
“author_id® AS tO0_r2,
“user_id® AS t0_r3,
“issue_id® AS tO0_r4,

AS tO0_r5,
‘comments® AS tO0_ro6,
“activity_id® AS tO0_r7,
“spent_on”® AS t0_rs8,
“tyear® AS t0_r9,
“tmonth® AS tO0_rl0,
“tweek® AS tO_rll,
‘created_on® AS t0O_rl2,
‘updated_on® AS tO0_ril3,
*id' AS tl1_roO,

‘name” AS tl_rl,
‘position® AS tl_r2,
“is_default® AS tl_r3,
“type® AS tl_r4,
“active® AS tl_rb5,
‘project_id® AS tl_re6,
‘parent_id® AS tl_r7,
AS tl1_r8

“hours®

‘position_name’

INNER JOIN “projects’ ON “projects . id’ = “time_entries . project_id"

INNER JOIN "enumerations® ON "enumerations . id’ = “time_entries’ . activity_id"
AND “enumerations’ . type = 'TimeEntryActivity'

INNER JOIN ‘users’ ON ‘users . i1d’ = “time_entries . user_id"

AND “users . type  IN ('User', 'AnonymousUser')

LEFT OUTER JOIN issues ON issues.id =

time_entries.issue_id

AND (
projects.status IN (1, 5)
AND EXISTS (
SELECT
1 AS one
FROM
enabled_modules em
WHERE
2025-04-19 1/3




em.project_id = projects.id
AND em.name = 'issue_tracking'

WHERE
(
projects.status IN (1, 5)
AND EXISTS (
SELECT
1 AS one
FROM
enabled_modules em
WHERE
em.project_id = projects.id
AND em.name = 'time_tracking'
)
)
ORDER BY

time_entries.spent_on DESC,
time_entries.created_on DESC,
time_entries.id ASC

LIMIT
25 OFFSET O

Mysql : 8.0.37
Ruby : 3.2.4
Raile: 7.2.2

Related issues:
Related to Redmine - Defect #40728: Slow loading of global spent time list in... Closed

History

#1 - 2025-04-08 04:46 - Go MAEDA
- Related to Defect #40728: Slow loading of global spent time list in MySQL added

#2 - 2025-04-08 04:53 - Go MAEDA

- Status changed from New to Needs feedback

Could you please check if applying the changes in r23609 will improve performance?

#3 - 2025-04-08 06:38 - Yuvansri Thangavel

Yes, I'll check and let you know. Thanks for the update.

#4 - 2025-04-09 07:41 - Yuvansri Thangavel
- File iteration_1.png added

Hi Go MAEDA,
Now i got response with in 5 to 6 seconds avg.

Previously i do some modifications in the code for the quick response. | know it's not a good one
Because, i skip module exist condition validation in time_entry.rb model. Using the below line.

options[:skip_pre_condition] = true; in visible_condition function.

in my case, all my projects must have time entry module. That's why i made this change.
But now i applied your code change. Yep i got quick response now.

Thankyou, so much!

#5 - 2025-04-09 10:34 - Go MAEDA
- Status changed from Needs feedback to Closed

- Resolution set to Fixed

Thank you for your feedback. This issue was resolved by #40728.
https://www.redmine.org/projects/redmine/repository/svn/revisions/23609
https://www.redmine.org/issues/40728

| am closing this issue.
